<template>
  <div class="app-container">
    <!-- 搜索 -->
    <el-form inline size="mini">
      <el-form-item label="歌手名称：">
        <el-input v-model="form.name" placeholder="请输入歌手名称" clearable />
      </el-form-item>
      <el-form-item label="资源平台：">
        <el-select v-model="form.platformId" placeholder="请选择资源平台" clearable>
          <el-option v-for="item in platformOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="歌手性别：">
        <el-select v-model="form.sex" placeholder="请选择歌手性别" clearable>
          <el-option v-for="item in sexOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="所属地区：">
        <el-select v-model="form.singerArea" placeholder="请选择所属地区" clearable>
          <el-option v-for="item in regionOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="当前状态：">
        <el-select v-model="form.status" placeholder="请选择当前状态" clearable>
          <el-option v-for="item in onOrOffOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="getSearch">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="getRefresh">重置</el-button>
        <el-button type="primary" plain icon="el-icon-plus" @click="getDetail()"
          v-hasPermi="['music:singer:add']">新增</el-button>
      </el-form-item>
    </el-form>
    <!-- 列表 -->
    <el-table :data="tableData" v-loading="loading">
      <el-table-column label="ID" prop="id" align="center" show-overflow-tooltip />
      <el-table-column label="歌手名称" prop="name" align="center" show-overflow-tooltip />
      <el-table-column label="歌手头像" align="center" width="100px">
        <template slot-scope="scope">
          <el-image v-if="scope.row.coverUrl" :src="scope.row.coverUrl" />
        </template>
      </el-table-column>
      <el-table-column label="歌手性别" prop="sex" align="center" :formatter="sexFormatter" />
      <el-table-column label="所属地区" prop="singerArea" align="center" :formatter="areaFormatter" />
      <el-table-column label="资源平台" prop="platformId" align="center" :formatter="platformFormatter" />
      <el-table-column label="当前状态" prop="status" align="center" :formatter="statusFormatter" />
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <el-button type="text" @click="getDetail(scope.row.id, true)">查看</el-button>
          <span v-if="scope.row.status === 2">
            <el-button type="text" @click="getDetail(scope.row.id)" v-hasPermi="['music:singer:edit']"
              style="margin-left: 10px">编辑</el-button>
            <el-button type="text" @click="getChange(scope.row, 1)" v-hasPermi="['music:singer:up']">上架
            </el-button>
            <el-button type="delete" @click="getDelete(scope.row)" v-hasPermi="['music:singer:delete']">删除
            </el-button>
          </span>
          <el-button type="text" v-else @click="getChange(scope.row, 2)" v-hasPermi="['music:singer:down']">下架
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" :page.sync="form.pageNum" :limit.sync="form.pageSize"
      @pagination="getList" />
  </div>
</template>

<script>
import { list, remove, change } from '@/api/music/singer'
import { platformMixin, sexMixin, regionMixin, onOrOffMixin } from '@/mixin/index'
export default {
  mixins: [platformMixin, sexMixin, regionMixin, onOrOffMixin],
  data() {
    return {
      // 遮罩层
      loading: false,
      // 表单
      form: {
        pageNum: 1,
        pageSize: 10
      },
      // 总数据
      total: 0,
      // 列表
      tableData: []
    };
  },
  mounted() {
    // 获取资源平台
    this.getPlatform({
      audioType: 9
    })
    this.getList()
  },
  methods: {
    // 列表
    getList() {
      this.loading = true
      list(this.form).then(res => {
        if (res.code === 0) {
          this.tableData = res.data.records
          this.total = res.data.total
          this.loading = false
        }
      })
    },

    // 搜索
    getSearch() {
      this.form.pageNum = 1
      this.getList()
    },

    // 重置
    getRefresh() {
      this.form = {
        pageNum: 1,
        pageSize: 10
      }
      this.getList()
    },

    // 新增 编辑
    getDetail(id, boolean) {
      this.$router.push({
        path: `/music/singer/detail`,
        query: {
          id: id,
          disabled: boolean
        }
      })
    },

    // 上下架
    getChange(row, status) {
      let title = status === 1 ? '上架' : '下架'
      this.$confirm(`是否${title}${row.name}?`, '提示', {
        type: 'warning'
      }).then(() => {
        change(row.id, status).then(res => {
          if (res.code === 0) {
            this.$message.success(`${title}成功！`)
            this.getList()
          }
        })
      }).catch(() => { })
    },

    // 删除
    getDelete(row) {
      this.$confirm(`是否删除${row.name}`, '提示', {
        type: 'warning'
      }).then(() => {
        remove(row.id).then(res => {
          if (res.code === 0) {
            this.$message.success('删除成功！')
            this.getList()
          }
        })
      }).catch(() => { })
    },

    // 字典翻译
    sexFormatter(row) {
      return this.selectDictLabel(this.sexOptions, row.sex)
    },

    areaFormatter(row) {
      return this.selectDictLabel(this.regionOptions, row.singerArea)
    },

    platformFormatter(row) {
      return this.selectDictLabel(this.platformOptions, row.platformId)
    },

    statusFormatter(row) {
      return this.selectDictLabel(this.onOrOffOptions, row.status)
    }
  },
};
</script>